function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React, { useEffect, useState } from 'react';
import useNode from './useNode';
import { Form, Checkbox, Input, Select } from 'antd';
import ConfigLoading from './configLoading';
import ColumnSelect from '../../../../components/columnSelect';
import { getFieldNameError, getFieldInputErrorInfo } from './utils';
import '../styles/mergeColumn.less';
import _ from 'lodash';
// 合并列
var MergeColumnConfig = function MergeColumnConfig(_ref) {
  var node = _ref.node,
    nodeList = _ref.nodeList;
  var classPrefix = 'mergeColumn-config';
  var nodeData = node.getData();
  var _useState = useState(nodeData.label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState3 = useState((nodeData === null || nodeData === void 0 ? void 0 : nodeData.mergeList) || []),
    _useState4 = _slicedToArray(_useState3, 2),
    selectColumns = _useState4[0],
    setSelectColumns = _useState4[1];
  var _useState5 = useState(_objectSpread(_objectSpread({}, nodeData), {}, {
      separator: (nodeData === null || nodeData === void 0 ? void 0 : nodeData.customSeparator) ? 'custom' : nodeData === null || nodeData === void 0 ? void 0 : nodeData.separator
    })),
    _useState6 = _slicedToArray(_useState5, 2),
    formValue = _useState6[0],
    setFormValue = _useState6[1];
  var _useState7 = useState(nodeData.retain || false),
    _useState8 = _slicedToArray(_useState7, 2),
    retain = _useState8[0],
    setRetain = _useState8[1];
  var statusHandle = function statusHandle() {
    if (actName && selectColumns.length && formValue.fieldName && (formValue.separator !== 'custom' || formValue.separator === 'custom' && formValue.customSeparator)) {
      return true;
    } else {
      return false;
    }
  };
  useEffect(function () {
    node.updateData(_objectSpread(_objectSpread({}, formValue), {}, {
      mergeList: selectColumns,
      status: statusHandle() ? 'success' : 'failed',
      retain: retain,
      label: actName,
      customSeparator: (formValue === null || formValue === void 0 ? void 0 : formValue.separator) === 'custom' ? formValue.customSeparator : '',
      separator: formValue.separator === 'custom' ? formValue.customSeparator : formValue.separator
    }));
  }, [selectColumns, formValue, retain, actName]);
  var onValuesChange = function onValuesChange(_value, allData) {
    setFormValue(_objectSpread({}, allData));
  };
  if (loading) {
    return /*#__PURE__*/React.createElement(ConfigLoading, null);
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement(Form, {
    onValuesChange: onValuesChange,
    initialValues: _objectSpread(_objectSpread({}, formValue), {}, {
      separator: (formValue === null || formValue === void 0 ? void 0 : formValue.separator) ? formValue === null || formValue === void 0 ? void 0 : formValue.separator : ''
    })
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0")), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    name: "fieldName",
    colon: false,
    rules: [{
      validator: function validator(_, value) {
        if (value === '') {
          return Promise.reject(new Error('请输入字段名称'));
        }
        var msg = getFieldInputErrorInfo(value);
        if (msg) {
          return Promise.reject(new Error(msg));
        }
        if (getFieldNameError(nodeList, columnList, value, nodeData)) {
          return Promise.reject(new Error('字段名称已存在'));
        }
      }
    }]
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u65B0\u5EFA\u5B57\u6BB5\u540D\u79F0",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u6CE8\u91CA",
    name: "alias",
    colon: false
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u6CE8\u91CA",
    maxLength: 200,
    showCount: true
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u9009\u62E9\u5408\u5E76\u5B57\u6BB5",
    colon: false
  }, /*#__PURE__*/React.createElement(ColumnSelect, {
    options: columnList.filter(function (item) {
      return ['number', 'string'].includes(item.webType);
    }),
    value: selectColumns,
    onChange: setSelectColumns,
    max: 5,
    selectAll: true
  }), /*#__PURE__*/React.createElement(Checkbox, {
    checked: retain,
    onChange: function onChange(e) {
      return setRetain(e.target.checked);
    }
  }, "\u4FDD\u7559\u539F\u5B57\u6BB5")), /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u5206\u9694\u7B26",
    name: "separator",
    colon: false
  }, /*#__PURE__*/React.createElement(Select, {
    options: [{
      label: '无',
      value: ''
    }, {
      label: ';',
      value: ';'
    }, {
      label: ',',
      value: ','
    }, {
      label: '/',
      value: '/'
    }, {
      label: '-',
      value: '-'
    }, {
      label: '自定义',
      value: 'custom'
    }]
  })), formValue.separator === 'custom' && (/*#__PURE__*/React.createElement(Form.Item, {
    label: "\u81EA\u5B9A\u4E49\u5206\u9694\u7B26",
    name: "customSeparator",
    colon: false,
    rules: [{
      required: true,
      message: '请输入自定义分隔符'
    }],
    getValueFromEvent: function getValueFromEvent(event) {
      return event.target.value.replace(/\s+/g, '');
    }
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: "\u8BF7\u8F93\u5165\u81EA\u5B9A\u4E49\u5206\u9694\u7B26",
    maxLength: 5,
    showCount: true
  })))));
};
export default MergeColumnConfig;